GNU Radio's TEST Package

Public Member Functions | Static Public Member Functions | Friends | List of all members
redpitaya_sink_c Class Reference

`#include <redpitaya_sink_c.h>`

Inheritance diagram for redpitaya_sink_c:

## Public Member Functions
| ~redpitaya_sink_c ()
int | work (int noutput_items, gr_vector_const_void_star &input_items, gr_vector_void_star &output_items)
std::string | name ()
size_t | get_num_channels (void)
osmosdr::meta_range_t | get_sample_rates (void)
double | set_sample_rate (double rate)
double | get_sample_rate (void)
osmosdr::freq_range_t | get_freq_range (size_t chan=0)
double | set_center_freq (double freq, size_t chan=0)
double | get_center_freq (size_t chan=0)
double | set_freq_corr (double ppm, size_t chan=0)
double | get_freq_corr (size_t chan=0)
std::vector< std::string > | get_gain_names (size_t chan=0)
osmosdr::gain_range_t | get_gain_range (size_t chan=0)
osmosdr::gain_range_t | get_gain_range (const std::string &name, size_t chan=0)
double | set_gain (double gain, size_t chan=0)
double | set_gain (double gain, const std::string &name, size_t chan=0)
double | get_gain (size_t chan=0)
double | get_gain (const std::string &name, size_t chan=0)
std::vector< std::string > | get_antennas (size_t chan=0)
std::string | set_antenna (const std::string &antenna, size_t chan=0)
std::string | get_antenna (size_t chan=0)
Public Member Functions inherited from sink_iface
virtual | ~sink_iface ()=default
virtual size_t | get_num_channels (void)=0
virtual osmosdr::meta_range_t | get_sample_rates (void)=0
virtual double | set_sample_rate (double rate)=0
virtual double | get_sample_rate (void)=0
virtual osmosdr::freq_range_t | get_freq_range (size_t chan=0)=0
virtual double | set_center_freq (double freq, size_t chan=0)=0
virtual double | get_center_freq (size_t chan=0)=0
virtual double | set_freq_corr (double ppm, size_t chan=0)=0
virtual double | get_freq_corr (size_t chan=0)=0
virtual std::vector< std::string > | get_gain_names (size_t chan=0)=0
virtual osmosdr::gain_range_t | get_gain_range (size_t chan=0)=0
virtual osmosdr::gain_range_t | get_gain_range (const std::string &name, size_t chan=0)=0
virtual bool | set_gain_mode (bool automatic, size_t chan=0)
virtual bool | get_gain_mode (size_t chan=0)
virtual double | set_gain (double gain, size_t chan=0)=0
virtual double | set_gain (double gain, const std::string &name, size_t chan=0)=0
virtual double | get_gain (size_t chan=0)=0
virtual double | get_gain (const std::string &name, size_t chan=0)=0
virtual double | set_if_gain (double gain, size_t chan=0)
virtual double | set_bb_gain (double gain, size_t chan=0)
virtual std::vector< std::string > | get_antennas (size_t chan=0)=0
virtual std::string | set_antenna (const std::string &antenna, size_t chan=0)=0
virtual std::string | get_antenna (size_t chan=0)=0
virtual void | set_dc_offset (const std::complex< double > &offset, size_t chan=0)
virtual void | set_iq_balance (const std::complex< double > &balance, size_t chan=0)
virtual double | set_bandwidth (double bandwidth, size_t chan=0)
virtual double | get_bandwidth (size_t chan=0)
virtual osmosdr::freq_range_t | get_bandwidth_range (size_t chan=0)
virtual void | set_time_source (const std::string &source, const size_t mboard=0)
virtual std::string | get_time_source (const size_t mboard)
virtual std::vector< std::string > | get_time_sources (const size_t mboard)
virtual void | set_clock_source (const std::string &source, const size_t mboard=0)
virtual std::string | get_clock_source (const size_t mboard)
virtual std::vector< std::string > | get_clock_sources (const size_t mboard)
virtual double | get_clock_rate (size_t mboard=0)
virtual void | set_clock_rate (double rate, size_t mboard=0)
virtual ::osmosdr::time_spec_t | get_time_now (size_t mboard=0)
virtual ::osmosdr::time_spec_t | get_time_last_pps (size_t mboard=0)
virtual void | set_time_now (const ::osmosdr::time_spec_t &time_spec, size_t mboard=0)
virtual void | set_time_next_pps (const ::osmosdr::time_spec_t &time_spec)
virtual void | set_time_unknown_pps (const ::osmosdr::time_spec_t &time_spec)

## Static Public Member Functions
static std::vector< std::string > | get_devices (bool fake=false)

## Friends
redpitaya_sink_c_sptr | make_redpitaya_sink_c (const std::string &args)

## Constructor & Destructor Documentation

## ◆ ~redpitaya_sink_c()

redpitaya_sink_c::~redpitaya_sink_c | ( |  | ) |

## Member Function Documentation

## ◆ get_antenna()

std::string redpitaya_sink_c::get_antenna | ( | size_t | chan = `0` | ) |
| virtual

Get the actual underlying radio hardware antenna setting.

Parameters

  chan | the channel index 0 to N-1

Returns
  the actual antenna's name

Implements sink_iface.

## ◆ get_antennas()

std::vector< std::string > redpitaya_sink_c::get_antennas | ( | size_t | chan = `0` | ) |
| virtual

Get the available antennas of the underlying radio hardware.

Parameters

  chan | the channel index 0 to N-1

Returns
  a vector of strings containing the names of available antennas

Implements sink_iface.

## ◆ get_center_freq()

double redpitaya_sink_c::get_center_freq | ( | size_t | chan = `0` | ) |
| virtual

Get the center frequency the underlying radio hardware is tuned to. This is the actual frequency and may differ from the frequency set.

Parameters

  chan | the channel index 0 to N-1

Returns
  the frequency in Hz

Implements sink_iface.

## ◆ get_devices()

static std::vector< std::string > redpitaya_sink_c::get_devices | ( | bool | fake = `false` | ) |
| static

## ◆ get_freq_corr()

double redpitaya_sink_c::get_freq_corr | ( | size_t | chan = `0` | ) |
| virtual

Get the frequency correction value.

Parameters

  chan | the channel index 0 to N-1

Returns
  correction value in parts per million

Implements sink_iface.

## ◆ get_freq_range()

osmosdr::freq_range_t redpitaya_sink_c::get_freq_range | ( | size_t | chan = `0` | ) |
| virtual

Get the tunable frequency range for the underlying radio hardware.

Parameters

  chan | the channel index 0 to N-1

Returns
  the frequency range in Hz

Implements sink_iface.

## ◆ get_gain() [1/2]

double redpitaya_sink_c::get_gain | ( | const std::string & | name,
|  | size_t | chan = `0`
| ) |  |
| virtual

Get the actual gain setting of a named stage.

Parameters

  name | the name of the gain stage
  chan | the channel index 0 to N-1

Returns
  the actual gain in dB

Implements sink_iface.

## ◆ get_gain() [2/2]

double redpitaya_sink_c::get_gain | ( | size_t | chan = `0` | ) |
| virtual

Get the actual gain setting of the underlying radio hardware.

Parameters

  chan | the channel index 0 to N-1

Returns
  the actual gain in dB

Implements sink_iface.

## ◆ get_gain_names()

std::vector< std::string > redpitaya_sink_c::get_gain_names | ( | size_t | chan = `0` | ) |
| virtual

Get the gain stage names of the underlying radio hardware.

Parameters

  chan | the channel index 0 to N-1

Returns
  a vector of strings containing the names of gain stages

Implements sink_iface.

## ◆ get_gain_range() [1/2]

osmosdr::gain_range_t redpitaya_sink_c::get_gain_range | ( | const std::string & | name,
|  | size_t | chan = `0`
| ) |  |
| virtual

Get the settable gain range for a specific gain stage.

Parameters

  name | the name of the gain stage
  chan | the channel index 0 to N-1

Returns
  the gain range in dB

Implements sink_iface.

## ◆ get_gain_range() [2/2]

osmosdr::gain_range_t redpitaya_sink_c::get_gain_range | ( | size_t | chan = `0` | ) |
| virtual

Get the settable overall gain range for the underlying radio hardware.

Parameters

  chan | the channel index 0 to N-1

Returns
  the gain range in dB

Implements sink_iface.

## ◆ get_num_channels()

size_t redpitaya_sink_c::get_num_channels | ( | void |  | ) |
| virtual

Get the number of channels the underlying radio hardware offers.

Returns
  the number of available channels

Implements sink_iface.

## ◆ get_sample_rate()

double redpitaya_sink_c::get_sample_rate | ( | void |  | ) |
| virtual

Get the sample rate for the underlying radio hardware. This is the actual sample rate and may differ from the rate set.

Returns
  the actual rate in Sps

Implements sink_iface.

## ◆ get_sample_rates()

osmosdr::meta_range_t redpitaya_sink_c::get_sample_rates | ( | void |  | ) |
| virtual

Get the possible sample rates for the underlying radio hardware.

Returns
  a range of rates in Sps

Implements sink_iface.

## ◆ name()

std::string redpitaya_sink_c::name | ( |  | ) |

## ◆ set_antenna()

std::string redpitaya_sink_c::set_antenna | ( | const std::string & | antenna,
|  | size_t | chan = `0`
| ) |  |
| virtual

Select the active antenna of the underlying radio hardware.

Parameters

  antenna | the antenna name
  chan | the channel index 0 to N-1

Returns
  the actual antenna's name

Implements sink_iface.

## ◆ set_center_freq()

double redpitaya_sink_c::set_center_freq | ( | double | freq,
|  | size_t | chan = `0`
| ) |  |
| virtual

Tune the underlying radio hardware to the desired center frequency. This also will select the appropriate RF bandpass.

Parameters

  freq | the desired frequency in Hz
  chan | the channel index 0 to N-1

Returns
  the actual frequency in Hz

Implements sink_iface.

## ◆ set_freq_corr()

double redpitaya_sink_c::set_freq_corr | ( | double | ppm,
|  | size_t | chan = `0`
| ) |  |
| virtual

Set the frequency correction value in parts per million.

Parameters

  ppm | the desired correction value in parts per million
  chan | the channel index 0 to N-1

Returns
  correction value in parts per million

Implements sink_iface.

## ◆ set_gain() [1/2]

double redpitaya_sink_c::set_gain | ( | double | gain,
|  | const std::string & | name,
|  | size_t | chan = `0`
| ) |  |
| virtual

Set the named gain on the underlying radio hardware.

Parameters

  gain | the gain in dB
  name | the name of the gain stage
  chan | the channel index 0 to N-1

Returns
  the actual gain in dB

Implements sink_iface.

## ◆ set_gain() [2/2]

double redpitaya_sink_c::set_gain | ( | double | gain,
|  | size_t | chan = `0`
| ) |  |
| virtual

Set the gain for the underlying radio hardware. This function will automatically distribute the desired gain value over available gain stages in an appropriate way and return the actual value.

Parameters

  gain | the gain in dB
  chan | the channel index 0 to N-1

Returns
  the actual gain in dB

Implements sink_iface.

## ◆ set_sample_rate()

double redpitaya_sink_c::set_sample_rate | ( | double | rate | ) |
| virtual

Set the sample rate for the underlying radio hardware. This also will select the appropriate IF bandpass, if applicable.

Parameters

  rate | a new rate in Sps

Implements sink_iface.

## ◆ work()

int redpitaya_sink_c::work | ( | int | noutput_items,
|  | gr_vector_const_void_star & | input_items,
|  | gr_vector_void_star & | output_items
| ) |  |

## Friends And Related Function Documentation

## ◆ make_redpitaya_sink_c

redpitaya_sink_c_sptr make_redpitaya_sink_c | ( | const std::string & | args | ) |
| friend

The documentation for this class was generated from the following file:

- redpitaya_sink_c.h